Attribute VB_Name = "SubClass"
Option Explicit
''''
''''
''''
''''
Private Const GWL_WNDPROC As Long = -4
Private Const WM_DESTROY As Long = &H2
''''
''''
''''
''''
Public Enum EErrorWindowProc
  eeBaseWindowProc = 13080 ' WindowProc
  eeCantSubclass           ' Can't subclass window
  eeAlreadyAttached        ' Message already handled by another class
  eeInvalidWindow          ' Invalid window
  eeNoExternalWindow       ' Can't modify external window
End Enum
''''
''''
''''
''''
Private Declare Function IsWindow Lib "user32.dll" ( _
   ByVal hWnd As Long) As Long
   
Private Declare Function GetProp Lib "user32.dll" Alias "GetPropA" ( _
   ByVal hWnd As Long, _
   ByVal lpString As String) As Long
   
Private Declare Function SetProp Lib "user32.dll" Alias "SetPropA" ( _
   ByVal hWnd As Long, _
   ByVal lpString As String, _
   ByVal hData As Long) As Long
   
Private Declare Function RemoveProp Lib "user32.dll" Alias "RemovePropA" ( _
   ByVal hWnd As Long, _
   ByVal lpString As String) As Long
   
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" ( _
   ByVal hWnd As Long, _
   ByVal nIndex As Long, _
   ByVal dwNewLong As Long) As Long
   
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" ( _
   ByVal hWnd As Long, _
   ByVal nIndex As Long) As Long
   
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" ( _
   ByVal lpPrevWndFunc As Long, _
   ByVal hWnd As Long, _
   ByVal msg As Long, _
   ByVal wParam As Long, _
   ByVal lParam As Long) As Long
   
Private Declare Function GetWindowThreadProcessId Lib "user32.dll" ( _
   ByVal hWnd As Long, _
   ByRef lpdwProcessId As Long) As Long
   
Private Declare Function GetCurrentProcessId Lib "kernel32.dll" () As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
   ByRef Destination As Any, _
   ByRef Source As Any, _
   ByVal Length As Long)
''''
''''
''''
''''
Private m_objISubclass As ISubclass
Private m_lngCurrentMessage As Long
Private m_lngProcOld As Long
Private m_f As Long
''''
''''
''''
''''
Public Property Get CurrentMessage() As Long
  CurrentMessage = m_lngCurrentMessage

End Property
''''
''''
''''
''''
Private Sub ErrRaise(e As Long)
  Dim sText As String, sSource As String
  
  If e > 1000 Then
    sSource = App.EXEName & ".WindowProc"
    
    Select Case e
      Case eeCantSubclass
        sText = "Can't subclass window"

      Case eeAlreadyAttached
        sText = "Message already handled by another class"

      Case eeInvalidWindow
        sText = "Invalid window"

      Case eeNoExternalWindow
        sText = "Can't modify external window"

    End Select
    
    Err.Raise e Or vbObjectError, sSource, sText

  Else
'    Raise standard Visual Basic error
    Err.Raise e, sSource

  End If

End Sub
''''
''''
''''
''''
Private Property Get MessageCount(ByVal hWnd As Long) As Long
  Dim strName As String
  
  strName = "C" & hWnd
  
  MessageCount = GetProp(hWnd, strName)
   
End Property

Private Property Let MessageCount(ByVal hWnd As Long, ByVal lngCount As Long)
  Dim strName As String

  m_f = 1

  strName = "C" & hWnd

  m_f = SetProp(hWnd, strName, lngCount)

  If (lngCount = 0) Then _
      RemoveProp hWnd, strName

'  logMessage "Changed message count for " & Hex(hWnd) & " to " & count

End Property
''''
''''
''''
''''
Private Property Get OldWindowProc(ByVal hWnd As Long) As Long
  Dim strName As String
  
  strName = hWnd
  
  OldWindowProc = GetProp(hWnd, strName)
  
End Property

Private Property Let OldWindowProc(ByVal hWnd As Long, ByVal lPtr As Long)
  Dim strName As String

  m_f = 1

  strName = hWnd

  m_f = SetProp(hWnd, strName, lPtr)

  If (lPtr = 0) Then _
      RemoveProp hWnd, strName

'  logMessage "Changed Window Proc for " & Hex(hWnd) & " to " & Hex(lPtr)

End Property
''''
''''
''''
''''
Private Property Get MessageClassCount(ByVal hWnd As Long, ByVal wMsg As Long) As Long
  Dim strName As String
  
  strName = hWnd & "#" & wMsg & "C"
  
  MessageClassCount = GetProp(hWnd, strName)
  
End Property

Private Property Let MessageClassCount(ByVal hWnd As Long, ByVal wMsg As Long, ByVal lngCount As Long)
  Dim strName As String
  
  strName = hWnd & "#" & wMsg & "C"
  
  m_f = SetProp(hWnd, strName, lngCount)
  
  If (lngCount = 0) Then
    RemoveProp hWnd, strName

  End If
  
'  logMessage "Changed message count for " & Hex(hWnd) & " Message " & wMsg & " to " & count

End Property
''''
''''
''''
''''
Private Property Get MessageClass(ByVal hWnd As Long, ByVal wMsg As Long, ByVal lIndex As Long) As Long
  Dim strName As String
  
  strName = hWnd & "#" & wMsg & "#" & lIndex
  
  MessageClass = GetProp(hWnd, strName)
  
End Property

Private Property Let MessageClass(ByVal hWnd As Long, ByVal wMsg As Long, ByVal lIndex As Long, ByVal classPtr As Long)
  Dim strName As String

  strName = hWnd & "#" & wMsg & "#" & lIndex

  m_f = SetProp(hWnd, strName, classPtr)

  If (classPtr = 0) Then _
      RemoveProp hWnd, strName

'  logMessage "Changed message class for " & Hex(hWnd) & " Message " & wMsg & " lIndex " & lIndex & " to " & Hex(classPtr)

End Property
''''
''''
''''
''''
Sub AttachMessage(iwp As ISubclass, ByVal hWnd As Long, ByVal wMsg As Long)
  Dim procOld As Long
  Dim msgCount As Long
  Dim msgClassCount As Long
  Dim msgClass As Long

'  --------------------------------------------------------------------
'  1) Validate window
'  --------------------------------------------------------------------
  If IsWindow(hWnd) = False Then
    ErrRaise eeInvalidWindow
    Exit Sub

  End If
  
  If IsWindowLocal(hWnd) = False Then
    ErrRaise eeNoExternalWindow
    Exit Sub

  End If

'  --------------------------------------------------------------------
'  2) Check if this class is already attached for this message:
'  --------------------------------------------------------------------
  msgClassCount = MessageClassCount(hWnd, wMsg)
  If (msgClassCount > 0) Then
    For msgClass = 1 To msgClassCount
      If (MessageClass(hWnd, wMsg, msgClass) = ObjPtr(iwp)) Then
        ErrRaise eeAlreadyAttached
        Exit Sub

      End If

    Next msgClass

  End If

'  --------------------------------------------------------------------
'  3) Associate this class with this message for this window:
'  --------------------------------------------------------------------
  MessageClassCount(hWnd, wMsg) = MessageClassCount(hWnd, wMsg) + 1
  If (m_f = 0) Then
'    Failed, out of memory:
    ErrRaise 5
    Exit Sub

  End If

'  --------------------------------------------------------------------
'  4) Associate the class pointer:
'  --------------------------------------------------------------------
  MessageClass(hWnd, wMsg, MessageClassCount(hWnd, wMsg)) = ObjPtr(iwp)
  If (m_f = 0) Then
'    Failed, out of memory:
    MessageClassCount(hWnd, wMsg) = MessageClassCount(hWnd, wMsg) - 1
    ErrRaise 5
    Exit Sub

  End If

'  --------------------------------------------------------------------
'  5) Get the message count
'  --------------------------------------------------------------------
  msgCount = MessageCount(hWnd)
  If msgCount = 0 Then

'    Subclass window by installing window procedure
    procOld = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WindowProc)
    If procOld = 0 Then
'      remove class:
      MessageClass(hWnd, wMsg, MessageClassCount(hWnd, wMsg)) = 0
'      remove class count:
      MessageClassCount(hWnd, wMsg) = MessageClassCount(hWnd, wMsg) - 1

      ErrRaise eeCantSubclass
      Exit Sub

    End If

'    Associate old procedure with handle
    OldWindowProc(hWnd) = procOld
    If m_f = 0 Then
'      SPM: Failed to VBSetProp, windows properties database problem.
'      Has to be out of memory.

'      Put the old window proc back again:
      SetWindowLong hWnd, GWL_WNDPROC, procOld
'      remove class:
      MessageClass(hWnd, wMsg, MessageClassCount(hWnd, wMsg)) = 0
'      remove class count:
      MessageClassCount(hWnd, wMsg) = MessageClassCount(hWnd, wMsg) - 1

'      Raise an error:
      ErrRaise 5
      Exit Sub

    End If

  End If


'  Count this message
  MessageCount(hWnd) = MessageCount(hWnd) + 1
  If m_f = 0 Then
'    SPM: Failed to set prop, windows properties database problem.
'    Has to be out of memory

'    remove class:
    MessageClass(hWnd, wMsg, MessageClassCount(hWnd, wMsg)) = 0
'    remove class count contribution:
    MessageClassCount(hWnd, wMsg) = MessageClassCount(hWnd, wMsg) - 1

'    If we haven't any messages on this window then remove the subclass:
    If (MessageCount(hWnd) = 0) Then
'      put old window proc back again:
      procOld = OldWindowProc(hWnd)
      If Not (procOld = 0) Then
        SetWindowLong hWnd, GWL_WNDPROC, procOld
        OldWindowProc(hWnd) = 0

      End If

    End If

'    Raise the error:
    ErrRaise 5
    Exit Sub

  End If

End Sub
''''
''''
''''
''''
Function AttachCommonDialog(iwp As ISubclass) As Long
  Set m_objISubclass = iwp
  
  AttachCommonDialog = plGetAddressOfFunction(AddressOf DialogProc)

End Function
''''
''''
''''
''''
Private Function DialogProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  m_objISubclass.WindowProc hWnd, wMsg, wParam, ByVal lParam

End Function
''''
''''
''''
''''
Sub DetachMessage(iwp As ISubclass, ByVal hWnd As Long, ByVal wMsg As Long)
  Dim msgClassCount As Long
  Dim msgClass As Long
  Dim msgClassIndex As Long
  Dim msgCount As Long
  Dim procOld As Long

'  --------------------------------------------------------------------
'  1) Validate window
'  --------------------------------------------------------------------
  If IsWindow(hWnd) = False Then
'    for compatibility with the old version, we don't
'    raise a message:
'    ErrRaise eeInvalidWindow
    Exit Sub

  End If
  If IsWindowLocal(hWnd) = False Then
'    for compatibility with the old version, we don't
'    raise a message:
'    ErrRaise eeNoExternalWindow
    Exit Sub

  End If

'  --------------------------------------------------------------------
'  2) Check if this message is attached for this class:
'  --------------------------------------------------------------------
  msgClassCount = MessageClassCount(hWnd, wMsg)
  If (msgClassCount > 0) Then
    msgClassIndex = 0
    For msgClass = 1 To msgClassCount
      If (MessageClass(hWnd, wMsg, msgClass) = ObjPtr(iwp)) Then
        msgClassIndex = msgClass
        Exit For

      End If

    Next msgClass

    If (msgClassIndex = 0) Then
'      fail silently
      Exit Sub

    Else
'      remove this message class:

'      a) Anything above this index has to be shifted up:
      For msgClass = msgClassIndex To msgClassCount - 1
        MessageClass(hWnd, wMsg, msgClass) = MessageClass(hWnd, wMsg, msgClass + 1)
      Next msgClass

'      b) The message class at the end can be removed:
      MessageClass(hWnd, wMsg, msgClassCount) = 0

'      c) Reduce the message class count:
      MessageClassCount(hWnd, wMsg) = MessageClassCount(hWnd, wMsg) - 1

    End If

  Else
'    fail silently
    Exit Sub

  End If

'  ---------------------------------------------------------------------
'  3) Reduce the message count:
'  ---------------------------------------------------------------------
  msgCount = MessageCount(hWnd)
  If (msgCount = 1) Then
'    remove the subclass:
    procOld = OldWindowProc(hWnd)
    If Not (procOld = 0) Then
'      Unsubclass by reassigning old window procedure
      Call SetWindowLong(hWnd, GWL_WNDPROC, procOld)

    End If
'    remove the old window proc:
    OldWindowProc(hWnd) = 0

  End If
  MessageCount(hWnd) = MessageCount(hWnd) - 1

End Sub
''''
''''
''''
''''
Private Function WindowProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Dim procOld As Long
  Dim msgClassCount As Long
  Dim bCalled As Boolean
  Dim pSubClass As Long
  Dim iwp As ISubclass
  Dim iwpT As ISubclass
  Dim iIndex As Long
  Dim bDestroy As Boolean

'  Get the old procedure from the window
  procOld = OldWindowProc(hWnd)
  Debug.Assert procOld <> 0

  If (procOld = 0) Then
'    we can't work, we're not subclassed properly.
    Exit Function

  End If

'  SPM - in this version I am allowing more than one class to
'  make a subclass to the same hWnd and Msg.  Why am I doing
'  this?  Well say the class in question is a control, and it
'  wants to subclass its container.  In this case, we want
'  all instances of the control on the form to receive the
'  form notification message.

'  Get the number of instances for this msg/hwnd:
  bCalled = False

  If (MessageClassCount(hWnd, wMsg) > 0) Then
    iIndex = MessageClassCount(hWnd, wMsg)

    Do While (iIndex >= 1)
    pSubClass = MessageClass(hWnd, wMsg, iIndex)

    If (pSubClass = 0) Then
'      Not handled by this instance

    Else
'      Turn pointer into a reference:
      CopyMemory iwpT, pSubClass, 4
      Set iwp = iwpT
      CopyMemory iwpT, 0&, 4

'      Store the current message, so the client can check it:
      m_lngCurrentMessage = wMsg

      With iwp
'        Preprocess (only checked first time around):
        If (iIndex = 1) Then
          If (.MsgResponse = emrPreprocess) Then
            If Not (bCalled) Then
              WindowProc = CallWindowProc(procOld, hWnd, wMsg, _
                  wParam, ByVal lParam)
              bCalled = True

            End If

          End If

        End If
'        Consume (this message is always passed to all control
'        instances regardless of whether any single one of them
'        requests to consume it):
        WindowProc = .WindowProc(hWnd, wMsg, wParam, ByVal lParam)

      End With

    End If

    iIndex = iIndex - 1
    Loop

'    PostProcess (only check this the last time around):
    If Not (iwp Is Nothing) And Not (procOld = 0) Then
      If iwp.MsgResponse = emrPostProcess Then
        If Not (bCalled) Then
          WindowProc = CallWindowProc(procOld, hWnd, wMsg, _
              wParam, ByVal lParam)
          bCalled = True

        End If

      End If

    End If

  Else
'    Not handled:
    If (wMsg = WM_DESTROY) Then
'      If WM_DESTROY isn't handled already, we should
'      clear up any subclass
      pClearUp hWnd
      WindowProc = CallWindowProc(procOld, hWnd, wMsg, _
          wParam, ByVal lParam)

    Else
      WindowProc = CallWindowProc(procOld, hWnd, wMsg, _
          wParam, ByVal lParam)

    End If

  End If

End Function
''''
''''
''''
''''
Public Function CallOldWindowProc( _
  ByVal hWnd As Long, _
      ByVal wMsg As Long, _
          ByVal wParam As Long, _
              ByVal lParam As Long _
                  ) As Long

  Dim iProcOld As Long

  iProcOld = OldWindowProc(hWnd)

  If Not (iProcOld = 0) Then _
      CallOldWindowProc = CallWindowProc(iProcOld, hWnd, wMsg, wParam, lParam)

End Function
''''
''''
''''
''''
Function IsWindowLocal(ByVal hWnd As Long) As Boolean
  Dim idWnd As Long
  
  Call GetWindowThreadProcessId(hWnd, idWnd)
  
  IsWindowLocal = (idWnd = GetCurrentProcessId())

End Function
''''
''''
''''
''''
Private Sub logMessage(ByVal sMsg As String)
  Debug.Print sMsg

End Sub
''''
''''
''''
''''
Private Sub pClearUp(ByVal hWnd As Long)
  Dim msgCount As Long
  Dim procOld As Long
'  this is only called if you haven't explicitly cleared up
'  your subclass from the caller.  You will get a minor
'  resource leak as it does not clear up any message
'  specific properties.
  msgCount = MessageCount(hWnd)
  
  If (msgCount > 0) Then
'    remove the subclass:
    procOld = OldWindowProc(hWnd)
    
    If Not (procOld = 0) Then
'      Unsubclass by reassigning old window procedure
      Call SetWindowLong(hWnd, GWL_WNDPROC, procOld)

    End If
    
'    remove the old window proc:
    OldWindowProc(hWnd) = 0
    
    MessageCount(hWnd) = 0

  End If

End Sub
''''
''''
''''
''''
Private Function plGetAddressOfFunction(lngPtr As Long) As Long
  plGetAddressOfFunction = lngPtr
  
End Function

